mod patterns;
mod bluetooth;

use patterns::{PixelColor, Strip};
use bluer::Device;
use bluer::gatt::remote::Characteristic;
use std::time::Duration;
use tokio::time::sleep;
use crate::patterns::RainbowPattern;

const SERVICE_UUID: bluer::Uuid = bluer::Uuid::from_u128(0xadaf0900c33242a893bd25e905756cb8);
const PIXEL_DATA_UUID: bluer::Uuid = bluer::Uuid::from_u128(0xadaf0903c33242a893bd25e905756cb8);
const STRIP_SIZE: usize = 25;
const BASE_STRIP_DATA : [u8; 3] = [0x00, 0x00, 0x01];


#[tokio::main(flavor = "current_thread")]
async fn main() -> bluer::Result<()> {

    let adapter = bluetooth::create_session().await?;

    let devices = bluetooth::scan_devices(adapter, SERVICE_UUID).await;

    for device in devices {
        println!("{:?}", device);
    }



    Ok(())
}

// async fn send_seq(char: &Characteristic) -> bluer::Result<()> {
//     println!("  Characteristic flags : {:?}, ", char.flags().await?);
//
//     let mut strip_red : Strip<10> = Strip::default();
//     strip_red.strip.fill(PixelColor { red: 255, green: 0, blue: 0});
//
//     let mut strip_green: Strip<10> = Strip::default();
//     strip_green.strip.fill(PixelColor { red: 0, green: 255, blue: 0});
//
//     let pattern = RainbowPattern::<STRIP_SIZE> { current_iteration: 0,};
//
//
//     for strip in pattern {
//         write_strip(strip, char).await?;
//         sleep(Duration::from_millis(50)).await;
//     }
//
//     Ok(())
// }

// pub async fn write_strip<const N: usize>(data: Strip<N>, char: &Characteristic) -> bluer::Result<()> {
//     let frame = [BASE_STRIP_DATA.to_vec(), data.to_array()].concat();
//     print!("{:?}",frame);
//     char.write(&*frame).await?;
//     Ok(())
// }

// async fn connect(device: &Device, retries: u8) -> bluer::Result<()> {
//     if device.is_connected().await? {
//         return Ok(())
//     }
//     for i in 0..retries {
//         match device.connect().await {
//             Ok(()) => return Ok(()),
//             Err(_) => {
//                 println!("connection error ({}), retry…", i);
//             }
//         }
//
//     }
//
//     Err(bluer::Error {
//         kind: bluer::ErrorKind::ConnectionAttemptFailed,
//         message: "all attempts fail".parse().unwrap(),
//     })
// }

// async fn find_neopixel_service(device: &Device) -> bluer::Result<Option<Characteristic>> {
//     let addr = device.address();
//     let uuids = device.uuids().await?.unwrap_or_default();
//
//     if uuids.contains(&SERVICE_UUID) {
//         println!("service neopixel found for device {}", &addr);
//         match connect(device, 3).await {
//             Ok(()) => {
//                 println!("successefully connected");
//             }
//             Err(err) => {
//                 println!("unable to connect, trying new device, {}", err);
//                 return Err(err)
//             }
//         }
//         for service in device.services().await? {
//             if SERVICE_UUID == service.uuid().await? {
//                 for char in service.characteristics().await? {
//                     println!("uuid : {}", &char.uuid().await?);
//                     if PIXEL_DATA_UUID == char.uuid().await? {
//
//                         return Ok(Some(char));
//                     }
//
//                 }
//             }
//         }
//
//     }
//
//     Ok(None)
// }